function P=Quad_Clust_POCS_fun(D,Cx,Cy)
%D:sum of incluster elements
%Cy:each cluster's cardinality in y point set, column vector
%Cx:each cluster's cardinality in x point set, column vector
%%clustering POCS using quadratic programming

[N,M]=size(D);
P=ones(N,M);
%%%%%
culresult=ones(1,M);%%%<0 violate the constraints
while 1
    delta=(P>0);
    culmark=(culresult>0);%% 0 means constraint
    cul=(delta*Cy)./Cx;
    row=(Cx'*delta)./Cy';
    deltaD=delta.*D;
    %
    R=-delta;
    L=-diag(row);
    t=2*(sum(deltaD)')./Cy;
    K=-diag(cul);
    s=2*(sum(deltaD,2))./Cx;
    %%%%%%%%%%%
    actcul=find(culmark==0);
    if ~isempty(actcul)
        actN=length(actcul); %%%number of active mul
        Re=R(:,actcul);
        Le=L(actcul,actcul);
        te=t(actcul);
        %%%%%%%%%%%
        invcul=zeros(N,1);
        for ii=1:N
            if cul(ii)~=0
                invcul(ii)=1.0/cul(ii);
            end
        end
        invK=-diag(invcul);
        %%%%%%%%
        %%%%%%%
        tmp=Le-Re'*invK*Re;
        %%%
        [Qq,Rr,Ee]=qr(tmp);
        serial=find(abs(diag(Rr))>100*eps);
        Rr=Rr(serial,serial);
        Qq=Qq(:,serial);
        Z1=Rr\(Qq'*(2-te-2*Re'*invK*ones(N,1)+Re'*invK*s));
        Z2=zeros(actN-length(serial),1);
        mue=Ee*[Z1;Z2];
        %%%
        lambda=invK*(2-s-Re*mue);
        mu=zeros(M,1);
        mu(actcul)=mue;
    else
        lambda=inv(K)*(2-s);
        mu=zeros(M,1);
    end
    %%%%%%%%%%%
    P=0.5*delta.*(-lambda*Cy'-Cx*mu'+2*D)./(Cx*Cy');
    culresult=culmark.*(1-(Cx'*P));
    if sum(sum(P<0))==0 && sum(sum(culresult<0))==0
        break;
    end  
end
