function [Xtran,bend]=TPS_transform(Xe,Y,lamda1,lamda2)



%%% Xe: in homogeneous coordinates
%%% Y, Xtran: in normal coordinates



dim=size(Y,2);
N=size(Xe,1);

if size(Xe,2)==dim
    Xe=[Xe ones(N,1)];
end

dif=repmat(permute(Xe,[1,3,2]),[1,N,1])-repmat(permute(Xe,[3,1,2]),[N,1,1]);
distsqr=sum(dif.^2,3);
K=distsqr.*log(distsqr+eps);%%kernel


[Q,R]=qr(Xe);%%QR decomposition
q1=Q(:,1:dim+1);
q2=Q(:,dim+2:end);
R=R(1:dim+1,:);

%%%%%%%%%%%%%%%%%
A=[eye(dim) zeros(dim,1)];
B=eye(dim);

%%%
myinv=inv(R'*R+lamda2*A'*A);%%ok
myinv2=inv(q2'*K*K*q2+lamda1*q2'*K*q2-q2'*K*q1*R*myinv*R'*q1'*K*q2);
myd=q2'*K*Y-q2'*K*q1*R*myinv*(lamda2*A'*B+R'*q1'*Y);
gamma=myinv2*myd;
d=myinv*(lamda2*A'*B+R'*q1'*Y-R'*q1'*K*q2*gamma);

Xtran=Xe*d+K*q2*gamma; 

%%bending energy
bend=trace(gamma'*q2'*K*q2*gamma);