
clear
[X,Y]=generate_point_set('fish');

width=.071;method='neighbor';

% function [Xtran,bend,elapsed_time]=gradient_CQPOCS_main(X,Y,method,width)

Dim=size(Y,2); %%%dimension
N=size(X,1);M=size(Y,1); %%% cardinality 

switch method
    case 'neighbor'
        %%%nearest neighbor clustering
        Xin=cluster_fun(X(:,1:Dim)',width);
        Yin=cluster_fun(Y',width);
    case 'neighborN'
        rate=width;
        Xin=cluster_fun_N(X(:,1:2)',floor(rate*N)); %%%Dim=2 here
        Yin=cluster_fun_N(Y',floor(rate*M));
    case 'Kmean'
        rate=width;
        Xin= kmeans(X(:,1:2),floor(rate*N));%%returning the cluster indices of each point
        Yin=kmeans(Y,floor(rate*M));
    case 'Cmean'
        rate=width;
        [center,U,obj_fcn]=fcm(X(:,1:2),floor(rate*N));
        maxU = max(U);
        Xin=zeros(N,1);
        for ii=1:N
            tmp=find(U(:,ii)==maxU(ii));
            Xin(ii)=tmp(1);
        end
        %%%
        [center,U,obj_fcn]=fcm(Y,floor(rate*M));
        maxU = max(U);
        Yin=zeros(M,1);
        for ii=1:M
            tmp=find(U(:,ii)==maxU(ii));
            Yin(ii)=tmp(1);
        end
end


Nc=max(Xin);
Mc=max(Yin);
%%%each cluster's cardinality
Cx=zeros(Nc,1);
for ii=1:Nc
    seri=find(Xin==ii);
    Cx(ii)=length(seri);
end
%%%
Cy=zeros(Mc,1);
for ii=1:Mc
    seri=find(Yin==ii);
    Cy(ii)=length(seri);
end
%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%projection coef const
I=2*N;%%%number of iteration of main loop
zeta=1e-3;%%%permitted error
gamma=10;%%%step size
%%%projection variables
P=1/M*ones(N,M);%%%%initialization
k=0;%%%iteration variable
delta=1;%%%convergence variable


%%%optimization process
while k<I && delta>zeta
    P0=P;

    et=-sum((P(:)/N).*log(P(:)/N+eps))+log(1/N);%%entropy of P - entropy of a binary correspondence
    et=exp(et);
    [Xtran,bend]=TPS_transform(X,P(1:N,1:M)*Y, et, et*.01);
    %%% derivative with respect to P
    tmp=repmat(permute(Xtran,[1,3,2]),[1,M,1])- repmat(permute(Y,[3,1,2]),[N,1,1]); %%%N x M x 3
    dfP=sum(tmp.^2,3); %%%N x M
    %%%norm
    dfPnorm=sqrt(sumsqr(dfP));
    if dfPnorm>=1e-3
        dfP=dfP/dfPnorm;%%%normalize dfP
        D=P(1:N,1:M)-gamma*dfP; %%%gradient descent of P
        %%%conversion to clustering correspondnece
        Dc=zeros(Nc,Mc);
        %%%points to clusters conversion
        for ii=1:Nc
            Xser=(Xin==ii);
            for jj=1:Mc
                Yser=(Yin==jj);                
                Dc(ii,jj)=sum(sum(D(Xser,Yser)));
            end
        end
        %%%%clustering projection
        Pc=Quad_Clust_POCS_fun(Dc,Cx,Cy);%%POCS by clustering quad programming
        %%%clusters to points conversion
        P=Pc(Xin,Yin); 
        %%%%%%%%%%%%%%%%%%
    end
    
    delta=sumsqr(P-P0);
    k=k+1;
    %%%%%%%%%%%%%%%%%%%%%plot intermediate result
    plot_intermediate(Xtran,Y,6);
end

